//------------------------------------------------------------------------------
//
//   Greg's Blocks - BlockSawbench
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import java.util.ArrayList;
import net.minecraft.src.*;

public class BlockSawbench extends BlockContainer {

	public BlockSawbench(int id) {
		super(id, 0x00, Material.wood);
	}
	
	@Override
	public String getTextureFile() {
		return GregsBlocks.textureFile;
	}
	
//	public void addCreativeItems(ArrayList itemList) {
//		itemList.add(new ItemStack(this, 1));
//	}

	@Override
	public CreativeTabs getCreativeTabToDisplayOn() {
		return CreativeTabs.tabMisc;
	}
	
	@Override
	public void onBlockPlacedBy(World world, int x, int y, int z, EntityLiving player) {
		int angle = MathHelper.floor_double((player.rotationYaw * 4.0 / 360.0) + 0.5) & 3;
		//System.out.printf("BlockSawbench.onBlockPlacedBy: angle = %d\n", angle);
		world.setBlockMetadataWithNotify(x, y, z, angle);
	}
	
	@Override
	public int getBlockTextureFromSideAndMetadata(int side, int data) {
		int offset = 0;
		if (side == 0)
			offset = 5;
		else if (side == 1)
			offset = data & 1;
		else {
			int angle = 0;
			switch (side) {
				case 2: angle = 0; break;	// -X
				case 3: angle = 2; break; // +X
				case 4: angle = 1; break; // -Z
				case 5: angle = 3; break; // +Z
			}
			switch ((angle + data) & 3) {
				case 0: offset = 3; break; // -X
				case 1: offset = 2; break; // -Z
				case 2: offset = 4; break; // +X
				case 3: offset = 5; break; // +Z
			}
		}
		return blockIndexInTexture + offset;
	}

	@Override
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player,
		int par6, float par7, float par8, float par9)
	{
		//System.out.printf("BlockSawbench.onBlockActivated\n");
		if (!player.isSneaking()) {
			if (!world.isRemote) {
				//System.out.printf("BlockSawbench.onBlockActivated: opening gui\n");
				GregsBlocks.proxy.openGuiSawbench(world, x, y, z, player);
			}
			return true;
		}
		else
			return false;
	}

	@Override
	public TileEntity createNewTileEntity(World world) {
		return new TESawbench();
	}

//	public void onBlockRemoval(World world, int x, int y, int z) {

	@Override
	public void onBlockDestroyedByPlayer(World world, int x, int y, int z, int data) {
		Utils.dumpInventoryIntoWorld(world, x, y, z);
		super.onBlockDestroyedByPlayer(world, x, y, z, data);
	}
	
}
