//------------------------------------------------------------------------------
//
//   Greg's Blocks - ItemShape - Client
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import java.util.List;
import java.util.ArrayList;
import java.util.Random;
import net.minecraft.src.*;

public class ItemShape extends ItemBlock {

	static Random rand = new Random();

	public ItemShape(int id) {
		super(id);
	}

	@Override
	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world,
		int x, int y, int z, int face, float par8, float par9, float par10)
	{
		System.out.printf("ItemShape.onItemUse\n");
		if (super.onItemUse(stack, player, world, x, y, z, face, par8, par9, par10)) {
			TEShape te = BlockShape.lastPlacedTileEntity;
			if (te != null) {
				NBTTagCompound tag = stack.getTagCompound();
				if (tag != null) {
					System.out.printf("ItemShape.onItemUse: initialising TEShape\n");
					te.readShapeFromNBT(tag);
				}
			}
			return true;
		}
		return false;
	}

	@Override
	public boolean getShareTag() {
		return true;
	}

	@Override
	public void addInformation(ItemStack stack, EntityPlayer player, List lines, boolean par4) {
		NBTTagCompound tag = stack.getTagCompound();
		if (tag != null) {
			int shape = tag.getInteger("Shape");
			int baseBlockID = tag.getInteger("BaseID");
			int baseMetadata = tag.getInteger("BaseData");
			if (shape >= 0 && shape < TEShape.numShapes)
				lines.set(0, TEShape.shapeNames[shape]);
			else
				lines.set(0, lines.get(0) + " (" + shape + ")");
			Block baseBlock = Block.blocksList[baseBlockID];
			if (baseBlock != null) {
				String baseName = null;
				int baseItemIndex = baseBlock.idDropped(baseMetadata, rand, 0);
				//System.out.printf("ItemShape.addInformation: baseItemIndex = %d\n", baseItemIndex);
				Item baseItem = Item.itemsList[baseItemIndex];
				if (baseItem != null) {
					ItemStack baseStack = new ItemStack(baseItem, 1, baseMetadata);
					baseName = baseItem.getItemDisplayName(baseStack);
				}
				if (baseName == null)
					baseName = baseBlock.translateBlockName();
				String desc = "Cut from " + baseName + " (" + baseBlockID + ":" + baseMetadata + ")";
				lines.add(desc);
			}
		}
	}

}
